<template>
  <q-layout view="lHh LpR lFf">
    <q-header
      reveal
      :class="$q.dark.isActive ? 'header_dark' : 'header_normal'"
    >
      <q-toolbar>
        <q-btn
          @click="left = !left"
          flat
          round
          dense
          icon="menu"
          class="q-mr-sm"
        />
        <q-toolbar-title>
          <div class="row">
            <div class="col-12">
              <q-chip dense icon="person">ID: {{username}}</q-chip>
              <q-chip dense icon="calculate" :label="credit | toUSD" />
            </div>
            <div class="col-12">
              <VTextMarquee :speed="40" :content="message.join('; ')"></VTextMarquee>
            </div>
          </div>
        </q-toolbar-title>
        <div class="row" style="text-align: right;">
          <div class="col-12">{{ date }} {{ currentTime }}</div>
          <div class="col-12">
            <q-chip dense icon="event">English</q-chip>
            <q-chip clickable dense icon="directions" @click="logout">Logout</q-chip>
          </div>
        </div>
      </q-toolbar>
    </q-header>
    <q-drawer
      class="left-navigation text-white"
      show-if-above
      v-model="left"
      side="left"
      elevated
    >
      <div
        class="full-height"
        :class="$q.dark.isActive ? 'drawer_dark' : 'drawer_normal'"
      >
        <div style="height: calc(100% - 117px);padding:10px;">
          <q-toolbar>
            <q-toolbar-title>Smart Agent</q-toolbar-title>
          </q-toolbar>
          <hr />
          <q-scroll-area style="height:100%;">
            <el-menu :default-active="activeIndex" @select="handleSelect">
            <!-- <el-menu default-active="1"> -->
              <el-submenu index="1">
                <template slot="title">
                  <i class="el-icon-user-solid"></i><span>Account</span>
                </template>
                <el-menu-item index="1-1">Profile</el-menu-item>
                <el-menu-item index="1-2" @click="resetpassword">Change Paassword</el-menu-item>
              </el-submenu>
              <el-submenu index="2" v-show="is_super_admin">
                <template slot="title">
                  <i class="el-icon-user-solid"></i><span>Staff Managment</span>
                </template>
                <el-menu-item index="2-1" @click="click('staff')">Staff</el-menu-item>
              </el-submenu>
              <el-submenu index="3" v-show="is_super_admin">
                <template slot="title">
                  <i class="el-icon-s-custom"></i><span>Company Managment</span>
                </template>
                  <el-menu-item @click="click('company')" index="3-1">Company</el-menu-item>
                  <!-- <el-menu-item @click="click('report')" index="3-2">Report</el-menu-item>                 -->
              </el-submenu>
              <el-submenu index="4" >
                <template slot="title">
                  <i class="el-icon-s-custom"></i><span>Report</span>
                </template>
                  <el-menu-item @click="click('report')" index="4-1">Report</el-menu-item>
              </el-submenu>
              <el-submenu index="5" v-show="is_super_admin">
                <template slot="title">
                  <i class="el-icon-setting"></i><span>Setting</span>
                </template>
                <el-menu-item @click="click('role')" index="5-1" v-show="permissions['role']">Role</el-menu-item>
                <el-menu-item @click="click('provider')" index="5-2" v-show="permissions['provider']">Provider</el-menu-item>
                <el-menu-item @click="click('group')" index="5-3" v-show="permissions['group']">Group</el-menu-item>
                <el-menu-item @click="click('type')" index="5-4" v-show="permissions['type']">Type Game</el-menu-item>
                <el-menu-item @click="click('message')" index="5-5" v-show="permissions['message']">Messages</el-menu-item>
              </el-submenu>
              <el-submenu index="6" v-show="!is_super_admin">
                <template slot="title">
                  <i class="el-icon-s-custom"></i><span>Company Managment</span>
                </template>
                  <el-menu-item @click="click('owner')" index="6-1" v-show="role['2']">Owner</el-menu-item>
                  <el-menu-item @click="click('share')" index="6-2" v-show="role['3']">Share Holder</el-menu-item>
                  <el-menu-item @click="click('senior')" index="6-3" v-show="role['4']">Senior</el-menu-item>
                  <el-menu-item @click="click('agent')" index="6-4" v-show="role['5']">Agent</el-menu-item>
                  <!-- <el-menu-item @click="click('report')" index="5-5">Report</el-menu-item> -->
              </el-submenu>
            </el-menu>
          </q-scroll-area>
        </div>
      </div>
    </q-drawer>

    <q-dialog v-model="modal_add" persistent transition-show="flip-down" transition-hide="flip-up" >
      <q-card style="width: 700px; max-width: 80vw;">
        <q-bar>
          <q-space />
          <q-btn dense flat icon="close" v-close-popup>
            <q-tooltip>Close</q-tooltip>
          </q-btn>
        </q-bar>
        <q-card-section >
          <el-form :model="form" ref="form" :rules="rules" label-width="120px" class="demo-dynamic">
            <el-form-item label="Old Password" prop="old_password">
              <el-input type="password" v-model="form.old_password" autocomplete="off"></el-input>
            </el-form-item>
            <el-form-item label="New Password" prop="new_password">
              <el-input type="password" v-model="form.new_password" autocomplete="off"></el-input>
            </el-form-item>
            <el-form-item label="Confrim" prop="confrim">
              <el-input type="password" v-model="form.confrim" autocomplete="off"></el-input>
            </el-form-item>
          </el-form>
        </q-card-section>
        <q-card-actions align="right" class="bg-primary text-white">
          <q-btn push rounded color="primary" @click="submit()">Submit</q-btn>
          <q-btn push rounded color="primary" v-close-popup>Cancel</q-btn>
        </q-card-actions>
      </q-card>
    </q-dialog>

    <q-page-container>
      <q-page class="row no-wrap">
        <div class="col">
          <div class="full-height">
            <q-scroll-area class="col q-pr-sm full-height" visible>
              <router-view />
            </q-scroll-area>
          </div>
        </div>
      </q-page>
    </q-page-container>
  </q-layout>
</template>

<script>
import 'element-ui/lib/theme-chalk/index.css';
// import moment from 'moment'
// import MarqueeText from 'vue-marquee-text-component'
import { VTextMarquee } from 'vue-text-marquee'

export default {
  components:{  VTextMarquee },
  data() {
    var validatePass = (rule, value, callback) => {
      if (value === '') {
        callback(new Error('Please input the password'));
      } else {
        if (this.form.confrim !== '') {
          this.$refs.form.validateField('confrim');
        }
        callback();
      }
    };
    var validatePass2 = (rule, value, callback) => {
      if (value === '') {
        callback(new Error('Please input the new password again'));
      } else if (value !== this.form.new_password) {
        callback(new Error('Two inputs don\'t match!'));
      } else {
        callback();
      }
    };
    return {
      left: false,
      date: moment(new Date()).format('DD/MM/YYYY'),
      time: '',
      currentTime: null,
      options: ['English', 'Thai'],
      model: 'English',
      username: this.$q.sessionStorage.getItem('username'),
      credit: this.$q.sessionStorage.getItem('credit'),
      permissions: this.$q.sessionStorage.getItem('permissions'),
      role: {},
      is_super_admin: this.$q.sessionStorage.getItem('role') <= 1 ? true : false,
      form: {
        old_password: '',
        new_password: '',
        confrim: '',
      },
      rules: {
        old_password: [{ required: true, message: 'Please input password', trigger: 'blur'}],
        new_password: [{ required: true, validator: validatePass, trigger: 'blur' }],
        confrim: [{ required: true, validator: validatePass2, trigger: 'blur' }],
      },
      modal_add: false,
      activeIndex: '1',
      message: []
    }
  },

  async created() {
    this.currentTime = moment().format('LTS');
    setInterval(() => this.updateCurrentTime(), 1 * 1000)
    this.role[this.$q.sessionStorage.getItem('role')] = true
    await this.get_message()
    // console.log('permissions:', this.is_super_admin, this.$q.sessionStorage.getItem('role'))
  },

  methods: {
    click (route) {
      if (this.$route.name != route) {
        this.$router.push({ name: route })
      }
    },

    logout() {
      let ctx = this
      this.$services.member.logout()
      .then(function(data){
        ctx.$services.success("Logged out")
        ctx.$q.sessionStorage.clear()
        ctx.$router.push({ name: 'login' })
      })
      .catch(function(e){
        if (e.response.status == 401) {
          ctx.$router.push({name: 'login'})
        }else{
          ctx.$services.error(e.response)
        }
      })
    },

    updateCurrentTime() {
      this.currentTime = moment().format('LTS');
    },

    resetpassword(){
      this.modal_add = true
    },

    submit() {
      let ctx = this
      this.$refs.form.validate((valid) => {
        if (valid) {
          this.$services.member.resetpassword(this.form)
          .then(function (data) {
            ctx.logout()
          })
          .catch (function(e) {
            ctx.$services.error(e.response, ctx.$router)
          })
        }
      })
    },

    handleSelect(key, keyPath) {
      // console.log(key, keyPath);
    },

    async get_message() {
      let ctx = this
      let result = [] //.join(", ")
      this.$services.message.read({status: 1})
      .then(function(data){
        data.results.forEach((row) => {
          ctx.message.push(row.message)
        })
      })
      .catch(function(e){
        // console.log('error:', e)
        // ctx.$services.error(e.response, ctx.$router)
      })
    }
  },

  filters: {
    toUSD (value) {
      return `${value.toLocaleString()}`
    }
  }
};
</script>

<style>
.q-drawer {
  background-size: cover !important;
}

.drawer_normal {
  background-color: rgba(1, 1, 1, 0.75);
}

.drawer_dark {
  background-color: #010101f2;
}

.navigation-item {
  border-radius: 5px;
}

.tab-active {
  background-color: green;
}

body {
  background: #f1f1f1 !important;
}

.header_normal {
  background: linear-gradient(
    145deg,
    rgb(32, 106, 80) 15%,
    rgb(21, 57, 102) 70%
  );
}

.header_dark {
  background: linear-gradient(145deg, rgb(61, 14, 42) 15%, rgb(14, 43, 78) 70%);
}
</style>
